#!/usr/bin/perl
# WebTTS 3.0
# $Id: tts-install.pl,v 3.0 1999/08/01 23:23:48 gashalot Exp gashalot $
#
# (C) 1999 Robert Gash (gashalot@gashalot.com)
#
# This is the new installation script that creates the tables required to
# run WebTTS 3.0 using MySQL.
#
# USAGE
# Edit the variables below to match the settings you have choosen, the user
# that this script uses MUST have CREATE TABLE premissions in the $dbname
# database.  I recommend that you do not give the normal webtts user permission
# to CREATE/DROP under normal operating circumstances for added security.
#
# YOU MUST HAVE ALREADY CREATED THE DATABASE USED IN $dbname MANUALLY, CHECK
# YOUR MYSQL DOCS FOR HOW TO DO THIS.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#

use DBI;

# The database name we will make the WebTTS tables in, should already exsist
# and be defined in tts-inc.pl as well.
$dbname = "webtts";

# The database server's IP or hostname
$dbhost = "localhost";

# The port the DB runs on, you might need to change this, check with your DBA
$dbport = "3306";

# The user that has CREATE TABLE perms for the $dbname database.
$dbuser = "root";

# The $dbuser's password to login to MySQL, leave it as undef if there is no
# password
$dbpass = undef;

# This is the salt, it must match the one in tts-inc.pl exactly otherwise your
# crypted passwords won't work and you can't login at all, I'd recommend just
# leaving this alone.
$salt = "1D87Fqu76W";

# Our DSN, don't touch this unless you know exactly what you are doing.
$dsn = "DBI:mysql:database=$dbname;host=$dbhost;port=$dbport";

#### DON'T EDIT BELOW THIS LINE UNLESS YOU KNOW WHAT YOU ARE DOING ####

$dbh = DBI->connect($dsn, $dbuser, $dbpass);
$drh = DBI->install_driver("mysql");

$cryptpass = crypt("admintts", $salt);

## Create the tables

$sth = $dbh->prepare("CREATE TABLE users (
   user text NOT NULL,
   pass text NOT NULL,
   name text,
   email text,
   admin enum('Y','N')
);");

$sth->execute;
$sth->finish;

$sth = $dbh->prepare("CREATE TABLE tickets (tnum int(10) DEFAULT '0' NOT NULL
auto_increment, user text NOT NULL, cust text, cust_email text, cust_phone
text, type text, area text, stat text, description text, upd text, assignment
text, PRIMARY KEY (tnum));");

$sth->execute;
$sth->finish;

# Insert our admin/admintts user.
$sth = $dbh->prepare("INSERT INTO users (user, pass, name, email, admin) VALUES
('admin','$cryptpass','WebTTS Administrator','root\@localhost','Y');");
$sth->execute;
$sth->finish;

$dbh->disconnect;

exit(0);
