# WebTTS 3.0 Data Abstraction Layer module
# $Id: tts-dal.pl,v 3.0 1999/07/31 02:26:30 gashalot Exp gashalot $
# (C) 1998,1999 Robert Gash
# 
# Distributed under the GNU GPL, see the LICENSE file provided with the
# distribution
#

use DBI;

### BEGIN USERCHECK DAL ROUTINE
sub tts_db_checkuser {

	# Setup our datasource to pull the userfrom
	$dbh = DBI->connect($dsn, $dbuser, $dbpass);

	# Install the MySQL Driver
	$drh = DBI->install_driver("mysql");

	# Prepare our SQL statement
	$sth = $dbh->prepare("SELECT pass, name, email, admin FROM users WHERE user = '$user'");

	# Execute our SQL
	$sth->execute;
	
	# See how many rows this query affected, if there are dupes we don't do
	# anything
	$numrows = $sth->rows;

	if ($numrows == 1) {
		# Since we only have one row, select it from the database and read it
		# into @row
		@row = $sth->fetchrow_array;

		# Setup our variables and encrypt the user's password he gave to
		# compare against the DB's crypted password.
		$vpass = @row[0];
		$cpass = crypt("$pass", $salt);

		# Make sure that we say the user has failed auth before we check the
		# auth.
		$usercheck = 0;

		# If the passwords match read the user's info into the system vars.
		if ($cpass eq $vpass) {
			$name = @row[1];
			$email = @row[2];
			$adminbit = @row[3];

			# If the user is an administrator set his adminbit to 1
			if ($adminbit eq "Y") {
				$adminbit = 1;
			}

			# Let everyone know we passed authentication
			$usercheck = 1;
		}
	}
	
	# Clear out $sth if we need to use it again and disconnect
	$sth->finish;
	$dbh->disconnect;
}
### END USERCHECK DAL ROUTINE


### BEGIN SELECTION TABLE DAL ROUTINE
sub tts_db_seltable {

	# Connect to the database and install the MySQL driver
	$dbh = DBI->connect($dsn, $dbuser, $dbpass);
	$drh = DBI->install_driver("mysql");
	
	# Setup our part of the SELECT if we are using the customer fields
	if ($usecust == 1) {
		$ucsel = ", cust, cust_email, cust_phone";
	}

	# Setup our part of the SELECT if we are using the assignment fields
	if ($useassign == 1) {
		$uasel = ", assignment";
	}

	# If our string is blank or it's not set to the all-but-closed var
	# then setup our WHERE clause to select just those tickets of non-closed
	# status
	if ($string eq "" || $string eq "$all") {
		$where = " WHERE stat NOT LIKE 'Closed'";
	
	# Otherwise we'll give the user the ticket status types they asked for.
	} else {
		$where = " WHERE stat LIKE '$string'";
	}
	
	# prepare our SELECT adding in our WHERE clause and cust and assign areas
	# if needed and execute the SELECT
	$sth = $dbh->prepare("SELECT tnum, user, type, area, stat$ucsel$uasel FROM tickets$where\;");
	$sth->execute;

	# since we'll probably have multiple tickets make sure we do this for all
	# of them
	while (@row = $sth->fetchrow_array) {
		# read in our input from the @row so we can print our table row
		$tnum = @row[0];
		$useradd = @row[1];
		$type = @row[2];
		$area = @row[3];
		$stat = @row[4];

		# setup the cust fields if applicable
		if ($usecust == 1) {
			$cust = @row[5];
			$cust_email = @row[6];
			$cust_phone = @row[7];
		}
		
		# since the assignment fields might be in different areas make sure
		# that we get the proper row slot for the assignment fields
		if ($useassign == 1 && $usecust == 0) {
			$assignment = @row[5];
		} elsif ($useassign == 1 && $usecust == 1) {
			$assignment = @row[8];
		}
		
		# Do our table row
		print "<tr><td><input type=radio name=ticket value=$tnum></td>";
		print "<td>$tnum</td><td>$useradd</td>";
		if ($usecust == 1) {
			print "<td>$cust</td><td>$cust_email</td>";
			print "<td>$cust_phone</td>";
		}
		if ($useassign == 1) {
			print "<td>$assignment</td>";
		}
		print "<td>$type</td><td>$area</td><td>$stat</td>";
		print "</tr>\n";
	}

	# clean up & disconnect from the DB
	$sth->finish;
	$dbh->disconnect;
}
### END SELECTION TABLE DAL ROUTINE

### BEGIN FETCH TICKET INFO DAL ROUTINE
sub tts_db_fetchticket {

	# Initalize our DB connection and install the driver
	$dbh = DBI->connect($dsn, $dbuser, $dbpass);
	$drh = DBI->install_driver("mysql");
	
	# prepare our SELECT and then execute it
	$sth = $dbh->prepare("SELECT user, cust, cust_email, cust_phone, type,
	area, stat, description, upd, assignment FROM tickets WHERE tnum =
	'$ticket'\;");
	$sth->execute;

	# make sure we have only one row, otherwise this is no good and there is
	# an error in the tickets database.
	if ($sth->rows == 1) {
		# read data into our @row
		@row = $sth->fetchrow_array;

		# put data into meaningful variables from the @row
		$username = @row[0];
		$cust = @row[1];
		$cust_email = @row[2];
		$cust_phone = @row[3];
		$type = @row[4];
		$area = @row[5];
		$stat = @row[6];
		$desc = @row[7];
		$upd = @row[8];
		$assignment = @row[9];

	# If we have more than 1 row something is bad wrong so tell the user.
	} else {
		&HTMLTop;
		print "WebTTS FATAL ERROR";
		&HTMLBod;
		print "<h1>WebTTS FATAL ERROR</h1>\n";
		print "Your search did not return a valid row or it returned too many
		rows from the database.\n";
		print "  Please use your browser's back button and make sure";
		print " you selected a valid ticket number if entered by hand";
		print " or you selected a ticket.  If you are sure that this";
		print " is a valid ticket number please contact your administrator";
		print " and have him/her check the error logfiles for the source";
		print " of the error.\n";
		&HTMLBot;
		
		exit(0);
	}

	# clean up and disconnect
	$sth->finish;
	$dbh->disconnect;
}
### END FETCH TICKET DAL ROUTINE

### BEGIN INSERT TICKET DAL ROUTINE
sub tts_db_insertticket {

	# initialize our db connection
	$dbh = DBI->connect($dsn, $dbuser, $dbpass);
	$drh = DBI->install_driver("mysql");

	# prepare our INSERT statement and execute it
	$sth = $dbh->prepare("INSERT INTO tickets \(user, cust, cust_email, cust_phone, type, area, stat, description, upd, assignment\) VALUES \('$user','$cust','$cust_email','$cust_phone','$prob','$area','Open','$desc','','$assignment'\)\;");
	$sth->execute;

	# Clean up this insert
	$sth->finish;
	
	# we need to give the user the ticket # to run another query to get the
	# last auto_incremented field value since the db does our ticket # assign
	# now
	$sth = $dbh->prepare('SELECT LAST_INSERT_ID()');
	$sth->execute;
	$tnum = $sth->fetchrow_arrayref->[0];

	# clean up and disconnect
	$sth->finish;

	$dbh->disconnect;
}
### END INSERT TICKET DAL ROUTINE

### BEGIN EDIT TICKET DAL ROUTINE
sub tts_db_editticket {

	# connect and install db driver
	$dbh = DBI->connect($dsn, $dbuser, $dbpass);
	$drh = DBI->install_driver("mysql");

	# prepare our SELECT statement to get some vals out that aren't changeable
	$sth = $dbh->prepare("SELECT user, type, area, description, upd, assignment FROM tickets WHERE tnum='$etkt'\;");
	
	# execute the SELECT
	$sth->execute;

	# make sure we only have one row or something is BAD wrong
	if ($numrows == 1) {
		# read data into vars
		@row = $sth->fetchrow_array;
		$username = @row[0];
		$area = @row[2];
		$type = @row[1];
		$desc = @row[3];
		$upda = @row[4];
		$assignment = @row[5];
	} else {
		# if we died b/c of multiple rows someone is tampering with the DB so
		# die and give user the Internal Server error and dump out to the error
		# log and don't touch anything so we don't break it.
		die("FATAL ERROR -- TOO MANY ROWS SELECTED FOR THE UPDATE TICKET");
	}
	
	# clean up our SELECT
	$sth->finish;

	# make the updates field have the proper markings again and tag with the
	# user's info
	if ($upda ne "") {
	 	$update = "$upda \n<br> $tag ($name\, $email) $date<br>
		$update<br>";
	} else { 
		$update = "$tag ($name\, $email) $date<br> $update<br>";
	}

	# prepare our UPDATE statement here
	$sth = $dbh->prepare("UPDATE tickets SET cust='$cust', cust_email='$cust_email', cust_phone='$cust_phone', type='$type', area='$area', stat='$stat', description='$desc', upd='$update' WHERE tnum = '$etkt'\;");

	# cleanup and disconnect
	$sth->execute;
	$sth->finish;

	$dbh->disconnect;
}
### END EDIT TICKET DAL ROUTINE

### BEGIN ADD USER DAL ROUTINE
sub tts_db_adduser {

	# connect and install db driver
	$dbh = DBI->connect($dsn, $dbuser, $dbpass);
	$drh = DBI->install_driver("mysql");

	# prepare our user insert
	$sth = $dbh->prepare("INSERT INTO users \(user, pass, name, email, admin\) VALUES \('$userid','$cpass','$usrname','$usremail','$usradmin'\)\;");
	
	# execute
	$sth->execute;

	# cleanup and disconnect
	$sth->finish;
	$dbh->disconnect;
}
### END ADD USER DAL ROUTINE

### BEGIN DELETE USER DAL ROUTINE
sub tts_db_deluser {

	# connect and install db driver
    $dbh = DBI->connect($dsn, $dbuser, $dbpass);
	$drh = DBI->install_driver("mysql");

	# ready our delete line and execute
	$sth = $dbh->prepare("DELETE FROM users WHERE user='$userid'\;");
	$sth->execute;

	# cleanup and disconnect
	$sth->finish;
	$dbh->disconnect;
}
### END DELETE USER DAL ROUTINE

### BEGIN CHANGE PASSWORD DAL ROUTINE
sub tts_db_userpasswd {

	# connect and install db driver
	$dbh = DBI->connect($dsn, $dbuser, $dbpass);
	$drh = DBI->install_driver("mysql");
	
	# ready our update line and execute
	$sth = $dbh->prepare("UPDATE users SET pass='$cpass' WHERE
	user='$userid'\;");

	$sth->execute;

	# cleanup and disconnect
	$sth->finish;
	$dbh->disconnect;
}
### END CHANGE PASSWORD DAL ROUTINE

### BEGIN FIND EMAIL DAL ROUTINE
sub tts_db_findemail {
	# connect and install db driver
	$dbh = DBI->connect($dsn, $dbuser, $dbpass);
	$drh = DBI->install_driver("mysql");

	# prepare the SELECT to get the assignment's email addr and execute
	$sth = $dbh->prepare("SELECT email FROM users WHERE user='$assignment'\;");

	$sth->execute;

	# setup vars
	$assignemail = $sth->fetchrow_arrayref->[0];	

	# cleanup and finish
	$sth->finish;
	$dbh->disconnect;
}
### END FIND EMAIL DAL ROUTINE
1;
